package com.serrano.aureo.lineaverde.utils;

import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;
import com.serrano.aureo.lineaverde.entities.Aviso;

import java.util.Date;
import java.util.List;

/**
 * Created by Aureo on 01/06/2016.
 */
public class ParseUtils
{

    public static List<Aviso> getAvisosFromServer() {
        List avisos = null;

        ParseQuery<Aviso> query = ParseQuery.getQuery(Aviso.class);
        query.orderByDescending("updatedAt");

        try {
            avisos = query.find();
        } catch (ParseException e) {
            e.printStackTrace();
            avisos = null;
        }

        return avisos;
    }

    public static List<Aviso> getAvisosSoloNoResueltosFecha(Date desde, Date hasta)
    {
        List avisos = null;

        ParseQuery<Aviso> query = ParseQuery.getQuery(Aviso.class);
        query.whereGreaterThanOrEqualTo("updatedAt",desde);
        query.whereLessThanOrEqualTo("updatedAt",hasta);
        query.whereNotEqualTo(Aviso.AVISO_ESTADO,3);
        query.orderByDescending("updatedAt");

        try {
            avisos = query.find();
        } catch (ParseException e) {
            e.printStackTrace();
            avisos = null;
        }

        return avisos;
    }

    public static List<Aviso> getAvisosFecha(Date desde, Date hasta)
    {
        List avisos = null;

        ParseQuery<Aviso> query = ParseQuery.getQuery(Aviso.class);
        query.whereGreaterThanOrEqualTo("updatedAt",desde);
        query.whereLessThanOrEqualTo("updatedAt",hasta);
        query.orderByDescending("updatedAt");

        try {
            avisos = query.find();
        } catch (ParseException e) {
            e.printStackTrace();
            avisos = null;
        }

        return avisos;
    }

    public static void saveAvisoToServer(ParseObject aviso)
    {
        try
        {
            aviso.save();
        }
        catch (ParseException e)
        {
            e.printStackTrace();
        }
    }

    public static Aviso getAvisoByID(String avisoID)
    {
        ParseQuery<Aviso> query = ParseQuery.getQuery(Aviso.class);

        Aviso aviso;

        try {
            aviso = query.get(avisoID);
        } catch (ParseException e) {
            e.printStackTrace();
            aviso = null;
        }

        return aviso;
    }

    public static List<Aviso> getAvisosByAndroidID(String androidID)
    {
        List avisos = null;

        ParseQuery<Aviso> query = ParseQuery.getQuery(Aviso.class);
        query.orderByDescending("updatedAt");
        query.whereEqualTo(Aviso.AVISO_ANDROID, androidID);
        query.whereEqualTo(Aviso.AVISO_VISIBLE, true);

        try {
            avisos = query.find();
        } catch (ParseException e) {
            e.printStackTrace();
            avisos = null;
        }

        return avisos;

    }

}
